#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Dec 22 17:09:46 2018

@author: Stefano Toniolo
"""
#%%

# =============================================================================
# import numpy as np
# import GPy as GPy
# 
# n=100
# x=np.linspace(-1,1,n)
# fy=x #this the function "f"
# y=fy+np.random.randn(n)*0.1 #this is the noisy output 
# 
# x = np.array([x]).T
# y = np.array([y]).T
# 
# model=GPy.models.GPRegression(x,y,kernel=GPy.kern.Matern32(1))
# model.optimize()
# model.plot()
# 
# def g(x,fy):
#     return fy**2
# 
# from acquisition.ei_mc import EIMC
# eimc = EIMC(model, g)
# 
# for x0 in x:
#     xnext = eimc.get_acquisition(x0)
#     print(x0, xnext)
# =============================================================================
    
#%%
    
import numpy as np
import GPy as GPy

n=10
x=np.linspace(-1,1,n)
fy=x #this the function "f"
y=fy+np.random.randn(n)*0.1 #this is the noisy output 

model=GPy.models.GPRegression(np.array([x]).T,np.array([y]).T,kernel=GPy.kern.Matern32(1))
model.optimize()
model.plot()

def g(x,fy):
    return fy**2

def Improvement(g,gmin,x,fy):
    return np.maximum(0,gmin-g(x,fy))

xnext=0.0 #assume xnext is fixed (actually we want to find it in BO)
m,v=model.predict(np.array([[xnext]]))
np.random.seed(42)#importante fissare il seed per l'ottimizzazione
N=1000 #this we can change it
z=m + v*np.random.randn(N) #generate random numbers from Gaussian with mean μ and variance σ^2


G=[]

for xi in x:
    m,none=model.predict(np.array([[xi]]))
    G.append(g(xi,m))
gmin=np.min(np.array(G))
print(gmin)

np.mean(Improvement(g,gmin,xnext,z))
