#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Nov 27 15:29:46 2018

@author: Stefano Toniolo
"""

from .optimizer import Optimizer

import numpy as np
from scipy.optimize import minimize

class SLSQP(Optimizer):
        
    def optimize(self, x0, f, df=None):
        if df is None:
            res = minimize(f, x0=x0, bounds=self.bounds, method='SLSQP')
        else:
            res = minimize(f, jac=df, x0=x0, bounds=self.bounds, method='SLSQP')
            
        result_x = np.atleast_2d(res.x)
        result_fx = np.atleast_2d(res.fun)
        
        return result_x, result_fx
    
    def set_bounds(self, bounds):
        self.bounds = bounds